/* c-basic-offset: 2; tab-width: 2; indent-tabs-mode: nil
 * vi: set shiftwidth=2 tabstop=2 expandtab:
 * :indentSize=2:tabSize=2:noTabs=true:
 */

#include <SDL2/SDL.h>
#include <stdbool.h>

#include "Game.h"

/**
 * This file, as the rest of the project is under MIT license.
 * see http://opensource.org/licenses/MIT
 *
 * Author Gustav Hartvigsson <gustav.hartvigsson _at_ gmail.com> 2014
 */

/******************************************************************************/


int main (int argc, char * argv[]) {
  
  Game * game = game_new ();
  
  game_main_loop (game);
  game_free (game);
  
  return 0;
}

